## <a id="global-variables"> Global Variables

Icinga 2 provides a number of special global variables:

Variable                  |Description
--------------------------|-------------------
IcingaPrefixDir           |**Read-only.** Contains the installation prefix that was specified with cmake -DCMAKE_INSTALL_PREFIX. Defaults to /usr/local
IcingaLocalStateDir       |**Read-only.** Contains the path of the local state directory. Defaults to IcingaPrefixDir + "/var".
IcingaPkgDataDir          |**Read-only.** Contains the path of the package data directory. Defaults to IcingaPrefixDir + "/share/icinga2".
IcingaStatePath           |**Read-write.** Contains the path of the Icinga 2 state file. Defaults to IcingaLocalStateDir + "/lib/icinga2/icinga2.state".
IcingaPidPath             |**Read-write.** Contains the path of the Icinga 2 PID file. Defaults to IcingaLocalStateDir + "/run/icinga2/icinga2.pid".
IcingaMacros              |**Read-write.** Contains a dictionary with global macros. Not set by default.
ApplicationType           |**Read-write.** Contains the name of the Application type. Defaults to "icinga/IcingaApplication".
IcingaEnableNotifications |**Read-write.** Whether notifications are globally enabled. Defaults to true.
IcingaEnableEventHandlers |**Read-write.** Whether event handlers are globally enabled. Defaults to true.
IcingaEnableFlapping      |**Read-write.** Whether flap detection is globally enabled. Defaults to true.
IcingaEnableChecks        |**Read-write.** Whether active checks are globally enabled. Defaults to true.
IcingaEnablePerfdata      |**Read-write.** Whether performance data processing is globally enabled. Defaults to true.
